06 2016 档案
摘要:DFS序在树上建出主席树,然后。。。。。
阅读全文
摘要:先求出凸包,旋转卡壳,可以枚举对角线,再分别找对角线两边最远的点。。。
阅读全文
摘要:2016-06-23 这种题果然不是我这种智商的人可以做的。。 网上两种做法,一种把树转化成括号序列 再用线段树维护好几个量(简直太神啦。。可惜蒟蒻看不懂) 还有一种是 先把树每次点分治的重心连向上一层的重心,重建一棵树。再来三个堆, C.每个重心存所有子树到其距离 B.每个重心存各个子树最大值,即
阅读全文
摘要:2016-06-23 难得一见的水题 我竟然wa了好几次,并不想多说什么。
阅读全文
摘要:2016-06-22 这个题就是找树中三个点到哪个点距离和最短,很明显是LCA,找这三个点两两之间的LCA,画个图看一下就行,很简单。
阅读全文
摘要:2016-06-22 这个题本想昨天晚上做来,但昨晚狂风大作,暴雨倾盆(听说我们学校最落后的一堵墙都被吹到了),停电了,我只能无聊的瞭望了教学楼一晚上。。。。。。 这个题把删除看成插入的话,插入一个点 新增逆序对就是比他早插入的,位置靠前,数比他大或 位置靠后,数比他小。那这就是个三维偏序集,可以用
阅读全文
摘要:2016-06-21 数字 难道是数位DP 可惜不是, 哎n<=10 我竟然没想到是状压DP, f[i][j]表示i这个状态%d==j的方案数有多少,转移的时候枚举哪一个做最后一位。
阅读全文
摘要:2016-06-21 读一下题目,发现环内肯定在一个半联通子图内,于是先tarjan缩点,然后就是找这个图的最长链及数目。拓扑一下即可。 注意注意 此题一定要将边进行判重。
阅读全文
摘要:2016-06-21 一看就是线段树,就是标记相互冲突,处理好,其余都是平常的。
阅读全文
摘要:2016-06-20 第一问是个二分的经典入门题 第二问很容易发现一个DP f[i][j]前i个木棍分j次合法方案数,f[i][j]=f[k][j-1]+...+f[i-1][j-1]; 但这样时间复杂度是O(mn^2),空间复杂度是O(mn) 但我们发现对于相同的j随着i的增加,对应的k也增加,那
阅读全文
摘要:2016-06-20 完全背包DP(做的时候都忘记自己当初怎么学得了 囧。。),题目非同寻常的地方是n很小,价值固定,但有多组测试数据,我们首先想到将之按完全背包预处理出来,每一组时再减去不合法的, 减去不合法的可以用容斥原理,第一个不合法的方案数就是让第一个先取d1+1个其余随便取 f[s-(d1
阅读全文
摘要:2016-06-20 这就是一个最大全0子矩阵 和 最大全0子正方形 不过把0改成01间隔,话说我把一个m打成n还过了一半
阅读全文
摘要:2016-06-20 一读完题,就知道这是一个数据结构体,c只有100这么小,那我们就用100课二维树状数组来维护就行了。树状数组绝对是世上最美妙的数据结构(果然我这种蒟蒻只能做这种sb题)
阅读全文
摘要:2016-06-20 一读完题目,马上就想到了田忌赛马,应该是贪心吧,就开始尝试各种姿势的贪心,最后受不鸟看了题解(果然我还是蒟蒻) 我们可以先排序(废话),对于最大值,我们从两头开始最弱的和最弱的比,最强的和最强的比 ,如果能打过就打,否则就让最弱的打敌方最强的,(平局不是能打过) 对于最小值,就
阅读全文

浙公网安备 33010602011771号